//+------------------------------------------------------------------+
//|                                                  CCI Woodie like |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_color1     clrDarkSlateGray
#property indicator_color2     clrBlue
#property indicator_color3     clrRed
#property indicator_color4     clrYellow
#property indicator_color5     clrLime
#property indicator_color6     clrRed
#property indicator_color7     clrBlack
#property indicator_color8     clrCrimson
#property indicator_width5     2
#property indicator_width6     2
#property indicator_width4     2
#property indicator_width7     2
#property indicator_levelcolor clrBlack
#property strict

//
//
//
//
//


extern int                CCIPeriod       = 14;             // Cci Period
extern int                TrendPeriod     = 6;              // Trend Period
extern int                TurboCCIPeriod  = 6;              // Turbo Cci Period
extern int                LSMAPeriod      = 25;             // LSMA Period(middle dots)
extern ENUM_APPLIED_PRICE LSMAPrice       = PRICE_CLOSE;    // Price to use for LSMA(middle dots)
extern double             upperlevelOs    = -200;           // Upper level oversold level
extern double             lowerlevelOs    = -100;           // Lower level oversold level
extern double             upperlevelOb    = 100;            // Upper level overbought level
extern double             lowerlevelOb    = 200;            // Lower level overbought level
extern bool               alertsOn        = true;           // Alerts on?
extern bool               alertsOnCurrent = false;          // Alerts on current open bar?
extern bool               alertsMessage   = true;           // Alerts message?
extern bool               alertsSound     = true;           // Alerts sound?
extern bool               alertsNotify    = false;          // Alerts Send Notification?
extern bool               alertsEmail     = false;          // Alerts send email?
extern string             soundFile       = "alert2.wav";   // Choose which sound file for alerts

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_ARROW);  SetIndexArrow(4,167);
   SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_ARROW);  SetIndexArrow(5,167);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
   SetLevelValue(0,upperlevelOb);
   SetLevelValue(1,lowerlevelOb);
   SetLevelValue(2,upperlevelOs);
   SetLevelValue(3,lowerlevelOs);

   IndicatorShortName("CCI Woodie ("+(string)CCIPeriod+","+(string)TurboCCIPeriod+")");
return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=fmin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i=limit;i>=0;i--)
   {
       if (TurboCCIPeriod>1) buffer8[i] = iCCI(NULL,0,TurboCCIPeriod,PRICE_TYPICAL,i); 
                             buffer7[i] = iCCI(NULL,0,CCIPeriod     ,PRICE_TYPICAL,i);
                             buffer1[i] = buffer7[i];
            SetHisto(i);
            SetLsma(i);
  }
  manageAlerts();
return(0);
}
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetHisto(int i)
{
   int k,s=0;

   buffer2[i] = EMPTY_VALUE;
   buffer3[i] = EMPTY_VALUE;
   buffer4[i] = EMPTY_VALUE;
   
   //
   //
   //
   //
   //

      if (buffer7[i]>0)
         if (buffer2[i+1] != EMPTY_VALUE) s = TrendPeriod;
         else
            for (k=1,s= 1; k<TrendPeriod; k++,s++) if (buffer3[i+k] != EMPTY_VALUE) break;

      if (buffer7[i]<0)
         if (buffer3[i+1] != EMPTY_VALUE) s = -TrendPeriod;
         else
            for (k=1,s=-1; k<TrendPeriod; k++,s--) if (buffer2[i+k] != EMPTY_VALUE) break;

      if (s ==  TrendPeriod) buffer2[i] = buffer7[i];
      if (s == -TrendPeriod) buffer3[i] = buffer7[i];
   
   //
   //
   //
   //
   //
   
   if (fabs(s) == (TrendPeriod-1)) buffer4[i] = buffer7[i];
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetLsma(int i)
{
   double ma1=iMA(NULL,0,LSMAPeriod,0,MODE_SMA ,LSMAPrice,i);
   double ma2=iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i);
   double lsmaValue = 3.0*ma2-2.0*ma1;
   
   buffer5[i] = EMPTY_VALUE;
   buffer6[i] = EMPTY_VALUE;
      if (Close[i] > lsmaValue) buffer5[i] =  0.00;
      if (Close[i] < lsmaValue) buffer6[i] =  0.00;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
    if (alertsOn)
    {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (buffer7[whichBar]>0 && buffer4[whichBar+1] == EMPTY_VALUE && buffer4[whichBar] != EMPTY_VALUE) doAlert(whichBar,"upper level yellow bar");
      if (buffer7[whichBar]<0 && buffer4[whichBar+1] == EMPTY_VALUE && buffer4[whichBar] != EMPTY_VALUE) doAlert(whichBar,"lower level yellow bar");
    }         
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," CCI Woodie ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " CCI Woodie "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}